﻿## 中文版教程：https://www.showdoc.cc/help 

### What is ShowDoc ?

Whenever we take over a module or project which has been developed by other people, we always feel crazy watching at those codes without notes. Where is the document?! Where is the document?! **Show me the doc !!**

A programmer often hopes the others to write technical documents, with the hope of not writing them on his/her own. Because writing a technical document needs a lot of time to handle the format and layout, and the person who writes it has to think of all kinds of non-technical details such as which catalog to put in the newly-established word document

All kinds of the word documents are kept by different persons in a team dispersedly. The person who needs other documents gets the documents by shouting out. He/She gives a shout asking for the documents and then receives them from other people by IMs or the e-mail. This kind of communication is not bad, but the efficiency is not high.

ShowDoc is a tool greatly applicable for an IT team to share documents online. It can promote communication efficiency among members of the team.

### What can it be used for?

- #### API Document （ [Demo](https://www.showdoc.cc/demo-en)）
 
 With the development of mobile Internet, BaaS (Backend as a Service) becomes more and more popular. The Server end provides API, and the APP end or Webpage frontend can invoke data conveniently. Using ShowDoc can compile exquisite API documents in a very fast and convenient way.

- #### Data Dictionary （ [Demo](https://www.showdoc.cc/demo-en)）
 
 A good Data Dictionary can easily exhibit database structure to other people, such as definition of each field and the like.

- #### Explanation Document （ [Demo](https://www.showdoc.cc/help-en)）
 
 You can absolutely use ShowDoc to compile the explanation documents for some tools, as well as to compile some technical specifications explanation documents for the team to look up.
 
### What functions does it have?

- #### Sharing and Exporting

 Responsive webpage design can share the project documents to computer or mobile devices for reading. It can also export the project into word document for browsing offline.
 
- #### Permission Management

 - Public Project and Private Project
 
   Projects on ShowDoc are divided into two categories including Public Project and Private Project. Public Project can be visited by any user no matter he/she logs in or not, while inputting password for verification is needed for visiting the Private Project. The password is set by project creator. 
   
  - Project Transfer
  
   The project creator can transfer the project to other users of the website freely.
   
  - Project Members
  
   You can easily add or delete project members in the project of ShowDoc. Members of the project can edit the project, but they can not transfer or delete the project (only creator of the project has the permission).
   
- #### Edit Function
  - Markdown Edit
  
   ShowDoc adopts Markdown Editor, and it is excellent both in editing and reading experience. If you know nothing about Markdown, please search “Learning and Introduction of Markdown” on the search engine.
   
  - Template Insert
  
   On the editing page of ShowDoc, a click on the button which is on the top of the Editor can easily insert API interface template and data dictionary template. After inserting the template, altering data is the only thing that need to do and it reduces a lot of work in editing.
   
  - History Version
  
   ShowDoc provides a function of History Version on the page, and you can easily restore the page to the former version.
   

### Deploy It to Your Own Server
 - ShowDoc Deploy
  
     Please refer to: [AutoInstall.md](https://github.com/star7th/showdoc/blob/master/documentation/en/AutoInstall.md)

 - Development & Contribution

   Please refer to: [Development&Contribution.md](https://github.com/star7th/showdoc/blob/master/documentation/en/Development&Contribution.md)
  

### Copyright 

 ShowDoc is issued complying with Apache2 Open Source License, and it is for free use. 
 
 Copyright ©  star7th 
 
 
 E-mail: [xing7th](mailto:xing7th@gmail.com)
 
 All rights reserved. 
 
